function global:Load-Classes([parameter(mandatory=$true)][string]$namespace)
#VISIBILITY:public
{
	$usingnamespacefilename = "class_.cs";
	$classroot = $SessionManager.GetValue("system.session.directory.classes") + $namespace + ([system.io.path]::DirectorySeparatorChar.ToString());

	## Add using-Directive To .CS File Content
	$usingnamespacefilenamelist = Get-ChildItem $classroot | ?{$_.name -eq $usingnamespacefilename};
	$classfilecontent = "";

	foreach($usingnamespacefilenamee in $usingnamespacefilenamelist)
	{
		$classfilecontent = Get-Content $usingnamespacefilenamee.fullname;
	}

	## Add class-Definitions To .CS File Content
	$classcontents = Get-ChildItem $classroot | ?{$_.name -ne $usingnamespacefilename};
	foreach($classconte in $classcontents)
	{
		$classfilecontent += Get-Content $classconte.fullname;
	}

	## Make Temporary .CS File Name
	$tempfilename = [system.io.path]::GetTempFileName();

	## Write .CS File
	$classfilecontent | out-file $tempfilename;

	$tempclassfilename = $tempfilename + ".cs";
	$newname = [system.io.path]::GetFileName($tempclassfilename);
	Rename-Item -path $tempfilename $newname;

	## Read class-Definitions
	Add-Type -path $tempclassfilename;

	## Remove .CS File
	Remove-Item $tempclassfilename;
}
