function global:Make-FunctionLibrary($folder)
#VISIBILITY:public
{
	$folderpath = $folder;
	if(([System.IO.Path]::GetFileName($folderpath)) -ne "")
	{
		$folderpath += ([System.IO.Path]::DirectorySeparatorChar.ToString());
	}

	$fi = new FunctionInterpreter;
	$fl = $fi.analyze();

	foreach($fe in $fl.List)
	{
		$tempproplist = "Parameter","calls","News";
		$tablehtml = @();
		foreach($pe in $tempproplist)
		{
			$templist = for($i = 0; $i -lt $fe.$pe.count; $i++)
			{
				$tempparam = new-object psobject;
				$tempparam | add-member -membertype noteproperty -name Seq -value $i -force;
				$tempparam | add-member -membertype noteproperty -name $pe -value $fe.$pe[$i] -force;
			}
			$html = $templist | convertto-html;

			$bcontain = $false;
			$binsertcap = $false;
			foreach($htmle in $html)
			{
				switch($htmle.ToUpper())
				{
					"<TABLE>"
					{
						$bcontain = $true;
						$binsertcap = $true;
					}
					default
					{
						#nop
					}
				}
				if($bcontain)
				{
					$tablehtml += $htmle;
					if($binsertcap)
					{
						$cap = "<caption>" + $pe + "</caption>";
						$tablehtml += $cap;
						$binsertcap = $false;
					}
				}
				switch($htmle.ToUpper())
				{
					"</TABLE>"
					{
						$bcontain = $false;
					}
					default
					{
						#nop
					}
				}
			}
			$tablehtml += "<BR>";
		}

		$nullhtml = $null | convertto-html -title $fe.name -body ("<a href=`"index.html`">Return</a><br>" + $fe.name) -head ($SessionManager.GetValue("system.session.definition.html.style"));
		$bcontain = $true;
		$funchtml = @();
		foreach($nullhtmle in $nullhtml)
		{
			switch($nullhtmle.ToUpper())
			{
				"<TABLE>"
				{
					$bcontain = $false;
					$funchtml += $tablehtml;
				}
				default
				{
					#nop
				}
			}
			if($bcontain)
			{
				$funchtml += $nullhtmle;
			}
			switch($nullhtmle.ToUpper())
			{
				"</TABLE>"
				{
					$bcontain = $true;
				}
				default
				{
					#nop
				}
			}
		}
		$funchtml | set-content ($folderpath + $fe.name + ".html");
	}

	$nh = $null | convertto-html -title "LibraryIndex" -body "LibraryIndex" -head ($SessionManager.GetValue("system.session.definition.html.style"));
	$fl = $fl.List | %{"<a href=`"" + $_.name + ".html`">" + $_.name + "</a><br>"};
	$fl = "<br>" + $fl;
	$indexhtml = @();
	$bcontain = $true;
	foreach($nhe in $nh)
	{
		switch($nhe.ToUpper())
		{
			"<TABLE>"
			{
				$bcontain = $false;
				$indexhtml += $fl;
			}
			default
			{
				#nop
			}
		}
		if($bcontain)
		{
			$indexhtml += $nhe;
		}
		switch($nhe.ToUpper())
		{
			"</TABLE>"
			{
				$bcontain = $true;
			}
			default
			{
				#nop
			}
		}
	}
	$indexhtml | set-content ($folderpath + "index.html");
}
